## onetbb 2021.5.0

=== src/tbbbind/CMakeLists.txt ===
# Copyright (c) 2020-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

if (DEFINED CMAKE_SKIP_BUILD_RPATH)
    set(CMAKE_SKIP_BUILD_RPATH_OLD_VALUE ${CMAKE_SKIP_BUILD_RPATH})
endif()
set(CMAKE_SKIP_BUILD_RPATH TRUE)

function(tbbbind_build TBBBIND_NAME REQUIRED_HWLOC_TARGET)
    if (NOT TARGET ${REQUIRED_HWLOC_TARGET})
        message(STATUS "HWLOC target ${REQUIRED_HWLOC_TARGET} doesn't exist."
                       " The ${TBBBIND_NAME} target cannot be created")
        return()
    endif()
    add_library(${TBBBIND_NAME} tbb_bind.cpp)
    add_library(TBB::${TBBBIND_NAME} ALIAS ${TBBBIND_NAME})

    target_compile_definitions(${TBBBIND_NAME}
                               PUBLIC
                               $<$<CONFIG:DEBUG>:TBB_USE_DEBUG>
                               PRIVATE
                               __TBBBIND_BUILD)
    target_include_directories(${TBBBIND_NAME}
        PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../include>
        $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
        ${HWLOC_INCLUDE_DIRS} # pkg-config defined
    )

    target_compile_options(${TBBBIND_NAME}
        PRIVATE
        ${TBB_CXX_STD_FLAG} # TODO: consider making it PUBLIC.
        ${TBB_MMD_FLAG}
        ${TBB_DSE_FLAG}
        ${TBB_WARNING_LEVEL}
        ${TBB_LIB_COMPILE_FLAGS}
        ${TBB_COMMON_COMPILE_FLAGS}
        ${TBB_IPO_COMPILE_FLAGS}
    )

    # Avoid use of target_link_libraries here as it changes /DEF option to \DEF on Windows.
    set_target_properties(${TBBBIND_NAME} PROPERTIES
        DEFINE_SYMBOL ""
        VERSION ${TBBBIND_BINARY_VERSION}.${TBB_BINARY_MINOR_VERSION}
        SOVERSION ${TBBBIND_BINARY_VERSION}
    )
    if (TBB_DEF_FILE_PREFIX) # If there's no prefix, assume we're using export directives
        set_target_properties(${TBBBIND_NAME} PROPERTIES
            LINK_FLAGS ${TBB_LINK_DEF_FILE_FLAG}${CMAKE_CURRENT_SOURCE_DIR}/def/${TBB_DEF_FILE_PREFIX}-tbbbind.def
            LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/def/${TBB_DEF_FILE_PREFIX}-tbbbind.def
        )
    endif()

    # Prefer using target_link_options instead of target_link_libraries to specify link options because
    # target_link_libraries may incorrectly handle some options (on Windows, for example).
    if (COMMAND target_link_options)
        target_link_options(${TBBBIND_NAME}
            PRIVATE
            ${TBB_LIB_LINK_FLAGS}
            ${TBB_COMMON_LINK_FLAGS}
            ${TBB_IPO_LINK_FLAGS}
        )
    else()
        target_link_libraries(${TBBBIND_NAME}
            PRIVATE
            ${TBB_LIB_LINK_FLAGS}
            ${TBB_COMMON_LINK_FLAGS}
            ${TBB_IPO_LINK_FLAGS}
        )
    endif()

    target_link_libraries(${TBBBIND_NAME}
        PUBLIC
        ${REQUIRED_HWLOC_TARGET}
        PRIVATE
        ${TBB_LIB_LINK_LIBS}
        ${TBB_COMMON_LINK_LIBS}
    )

    tbb_install_target(${TBBBIND_NAME})

    if (COMMAND tbb_gen_vars)
        tbb_gen_vars(${TBBBIND_NAME})
    endif()
endfunction()

if (NOT DEFINED HWLOC_TARGET_EXPLICITLY_DEFINED AND TARGET PkgConfig::HWLOC)
    message(STATUS "The ${TBBBIND_LIBRARY_NAME} target will be configured using the HWLOC ${HWLOC_VERSION}")
    tbbbind_build(${TBBBIND_LIBRARY_NAME} PkgConfig::HWLOC)
else()
    tbbbind_build(tbbbind     HWLOC::hwloc_1_11)
    tbbbind_build(tbbbind_2_0 HWLOC::hwloc_2   )
    tbbbind_build(tbbbind_2_5 HWLOC::hwloc_2_5 )
endif()


if (DEFINED CMAKE_SKIP_BUILD_RPATH_OLD_VALUE)
    set(CMAKE_SKIP_BUILD_RPATH ${CMAKE_SKIP_BUILD_RPATH_OLD_VALUE})
    unset(CMAKE_SKIP_BUILD_RPATH_OLD_VALUE)
else()
    unset(CMAKE_SKIP_BUILD_RPATH)
endif()

=== src/tbbmalloc/CMakeLists.txt ===
# Copyright (c) 2020-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

add_library(tbbmalloc 
    backend.cpp
    backref.cpp
    frontend.cpp
    large_objects.cpp
    tbbmalloc.cpp
    ../tbb/itt_notify.cpp)

add_library(TBB::tbbmalloc ALIAS tbbmalloc)

target_compile_definitions(tbbmalloc
                           PUBLIC
                           $<$<CONFIG:DEBUG>:TBB_USE_DEBUG>
                           PRIVATE
                           __TBBMALLOC_BUILD
                           $<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:__TBB_DYNAMIC_LOAD_ENABLED=0>
                           $<$<NOT:$<BOOL:${BUILD_SHARED_LIBS}>>:__TBB_SOURCE_DIRECTLY_INCLUDED=1>)

if (NOT ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "(armv7-a|aarch64|mips|arm64)" OR
         "${CMAKE_OSX_ARCHITECTURES}" MATCHES "arm64" OR
         WINDOWS_STORE OR
         TBB_WINDOWS_DRIVER OR
         TBB_SANITIZE MATCHES "thread"))
    target_compile_definitions(tbbmalloc PRIVATE __TBB_USE_ITT_NOTIFY)
endif()

target_include_directories(tbbmalloc
    PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../../include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>)

# TODO: fix warnings
if (MSVC)
    # signed unsigned mismatch, declaration hides class member
    set(TBB_WARNING_SUPPRESS ${TBB_WARNING_SUPPRESS} /wd4267 /wd4244 /wd4245 /wd4018 /wd4458)
endif()

# TODO: add ${TBB_WARNING_LEVEL} and fix problems
target_compile_options(tbbmalloc
    PRIVATE
    ${TBB_CXX_STD_FLAG} # TODO: consider making it PUBLIC.
    ${TBB_MMD_FLAG}
    ${TBB_DSE_FLAG}
    ${TBB_WARNING_SUPPRESS}
    ${TBB_LIB_COMPILE_FLAGS}
    ${TBBMALLOC_LIB_COMPILE_FLAGS}
    ${TBB_COMMON_COMPILE_FLAGS}
    ${TBB_IPO_COMPILE_FLAGS}
)

enable_language(C)

# Avoid use of target_link_libraries here as it changes /DEF option to \DEF on Windows.
set_target_properties(tbbmalloc PROPERTIES
    DEFINE_SYMBOL ""
    VERSION ${TBBMALLOC_BINARY_VERSION}.${TBB_BINARY_MINOR_VERSION}
    SOVERSION ${TBBMALLOC_BINARY_VERSION}
    LINKER_LANGUAGE C
)

if (TBB_DEF_FILE_PREFIX) # If there's no prefix, assume we're using export directives
    set_target_properties(tbbmalloc PROPERTIES
        LINK_FLAGS ${TBB_LINK_DEF_FILE_FLAG}${CMAKE_CURRENT_SOURCE_DIR}/def/${TBB_DEF_FILE_PREFIX}-tbbmalloc.def
        LINK_DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/def/${TBB_DEF_FILE_PREFIX}-tbbmalloc.def
    )
endif()

set(CMAKE_CXX_IMPLICIT_LINK_LIBRARIES "")

# Prefer using target_link_options instead of target_link_libraries to specify link options because
# target_link_libraries may incorrectly handle some options (on Windows, for example).
if (COMMAND target_link_options)
    target_link_options(tbbmalloc
        PRIVATE
        ${TBB_LIB_LINK_FLAGS}
        ${TBB_COMMON_LINK_FLAGS}
        ${TBB_IPO_LINK_FLAGS}
    )
else()
    target_link_libraries(tbbmalloc
        PRIVATE
        ${TBB_LIB_LINK_FLAGS}
        ${TBB_COMMON_LINK_FLAGS}
        ${TBB_IPO_LINK_FLAGS}
    )
endif()

target_link_libraries(tbbmalloc
    PRIVATE
    Threads::Threads
    ${TBB_LIB_LINK_LIBS}
    ${TBB_COMMON_LINK_LIBS}
)

tbb_install_target(tbbmalloc)

=== examples/parallel_reduce/convex_hull/CMakeLists.txt ===
# Copyright (c) 2020-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.1)

project(convex_hull_bench CXX)
project(convex_hull_sample CXX)

include(../../common/cmake/common.cmake)

set_common_project_settings(tbb)

add_executable(convex_hull_bench convex_hull_bench.cpp)
add_executable(convex_hull_sample convex_hull_sample.cpp)

target_link_libraries(convex_hull_bench TBB::tbb Threads::Threads)
target_link_libraries(convex_hull_sample TBB::tbb Threads::Threads)

target_compile_options(convex_hull_bench PRIVATE ${TBB_CXX_STD_FLAG})
target_compile_options(convex_hull_sample PRIVATE ${TBB_CXX_STD_FLAG})

add_custom_target(convex_hull)
add_dependencies(convex_hull convex_hull_bench convex_hull_sample)

set(EXECUTABLE "$<TARGET_FILE:convex_hull_bench>")
set(PERF_EXECUTABLE "$<TARGET_FILE:convex_hull_sample>")
set(ARGS "")
set(LIGHT_ARGS 4 400)
set(PERF_ARGS silent auto 40000000)

add_execution_target(run_convex_hull convex_hull ${EXECUTABLE} "${ARGS}")
add_execution_target(light_test_convex_hull convex_hull ${EXECUTABLE} "${LIGHT_ARGS}")
add_execution_target(perf_run_convex_hull convex_hull ${PERF_EXECUTABLE} "${PERF_ARGS}")

=== examples/task_arena/fractal/CMakeLists.txt ===
# Copyright (c) 2020-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.1)

project(fractal CXX)

include(../../common/cmake/common.cmake)

set_common_project_settings(tbb)

add_executable(fractal fractal.cpp main.cpp ) 

add_subdirectory(../../common/gui gui)

target_link_libraries(fractal PUBLIC TBB::tbb Threads::Threads UI_LIB_fractal)
target_compile_options(fractal PRIVATE ${TBB_CXX_STD_FLAG})

set(EXECUTABLE "$<TARGET_FILE:fractal>")
set(ARGS auto)
set(PERF_ARGS auto 1 1000000 silent)
set(LIGHT_ARGS auto 1 1000)

add_execution_target(run_fractal fractal ${EXECUTABLE} "${ARGS}")
add_execution_target(perf_run_fractal fractal ${EXECUTABLE} "${PERF_ARGS}")
add_execution_target(light_test_fractal fractal ${EXECUTABLE} "${LIGHT_ARGS}")

=== examples/test_all/fibonacci/CMakeLists.txt ===
# Copyright (c) 2019-2021 Intel Corporation
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.1)

project(fibonacci CXX)

include(../../common/cmake/common.cmake)

set_common_project_settings(tbb)

add_executable(fibonacci fibonacci.cpp)
target_link_libraries(fibonacci
                      TBB::tbb
                      Threads::Threads
                      $<$<PLATFORM_ID:Linux>:rt>)  # Link "rt" library on Linux
target_compile_options(fibonacci PRIVATE ${TBB_CXX_STD_FLAG})

set(EXECUTABLE "$<TARGET_FILE:fibonacci>")
set(ARGS "")

add_execution_target(run_fibonacci fibonacci ${EXECUTABLE} "${ARGS}")

=== debian/changelog ===
onetbb (2021.5.0-7ubuntu2) jammy; urgency=medium

  * Split out a libtbbmalloc2 package.
  * Mark some of the libtbbmalloc symbols as optional.
  * Build for riscv64.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 08 Mar 2022 09:55:56 +0100

onetbb (2021.5.0-7) experimental; urgency=medium

  * Remove fetchadd4-ia64-gcc.patch: generic fallback invalid for IA64.
  * Revise patch of test_collaborative_call_once for __arm__ and x32.
  * Add -faligned-new in CXXFLAGS for m68k and sh4.
  * Disable ITT_NOTIFY on IA64 architecture.

 -- Mo Zhou <lumin@debian.org>  Tue, 22 Feb 2022 12:51:02 -0500

onetbb (2021.5.0-6) experimental; urgency=medium

  * Patch and fix libatomic linkage on architectures incl. armel.
  * Reduce stress of test_collaborative_call_once on __arm__ and x32.
  * Revise fetchadd4.patch based on upstream suggestion.
  * Patch code to avoid undefined fetchadd4 on IA64 with gcc.

 -- Mo Zhou <lumin@debian.org>  Tue, 15 Feb 2022 10:16:19 -0500

onetbb (2021.5.0-5) experimental; urgency=medium

  * Patch source to avoid "undefined __TBB_machine_fetchadd4".
  * Overhaul buildflags definition for CMake. Deprecate old defs for Makefile.

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Feb 2022 21:53:17 -0500

onetbb (2021.5.0-4) experimental; urgency=medium

  * Cherry-pick 8f78aa096459b8ea0fcb54d2f0854f1889043f5d to fix test_eh_thread.
  * Prevent dh-missing from failing the build due to README.

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Feb 2022 15:48:13 -0500

onetbb (2021.5.0-3) experimental; urgency=medium

  * Cherry-pick upstream fix for i386.
  * Fix FTBFS for --arch-all --no-arch-any build.
  * Fix broken symlink in libtbb-doc. (Closes: #988868)

 -- Mo Zhou <lumin@debian.org>  Sun, 13 Feb 2022 13:50:43 -0500

onetbb (2021.5.0-2) experimental; urgency=medium

  * Breaks+Replaces: libtbb2 (<< 2021). (Closes: #1004980)
  * B-D on cmake for all architectures.
  * Reintroduce remove-unaligned-test.patch to fix bus error during test.

 -- Mo Zhou <lumin@debian.org>  Sat, 05 Feb 2022 17:57:13 -0500

onetbb (2021.5.0-1) experimental; urgency=medium

  * Team upload

  [ Mo Zhou ]
  * New upstream version 2021.4.0 (Closes: #987689)
  * Source rename following upstream. The new upstream Git URL is
    https://github.com/oneapi-src/oneTBB
  * d/rules: Switch build system to cmake+ninja.
    + Remove OS detection flags for old buildsystem.
    + Update buildflags in favor of new CMake buildsystem.
    + No longer need to manually install pkg-config and cmake files.
  * d/patches: Remove patches for old build system.
    + And temporarily disable all remaining patches.
  * Bump SOVERSION to 12 and refresh symbols control file. (Closes: #997115)
  * Migrate to Sphinx for building documentation.
  * d/*.{install,docs,examples}: Reflect upstream file changes.
  * Remove unnecessary links and lintian overrides.
  * Migrate to new API for d/tests/test.cc for autopkgtest.
  * Use upstream examples for autopkgtest.
  * Upload to experimental.

  [ Andreas Tille ]
  * Do not repack upstream source
  * DEP5
  * Drop uupdate from watch file
  * Standards-Version: 4.6.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * No need to use dh-exec

 -- Andreas Tille <tille@debian.org>  Thu, 03 Feb 2022 17:14:25 +0100

tbb (2020.3-1) unstable; urgency=medium

  * New upstream version 2020.3
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Thu, 13 Aug 2020 08:33:57 +0800

tbb (2020.2-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Mon, 13 Apr 2020 07:56:18 +0800

tbb (2020.2-1) experimental; urgency=medium

  * New upstream version 2020.2
  * Specify Rules-Requires-Root: no in control
  * Bump Standards-Version to 4.5.0 (no change).

 -- Mo Zhou <lumin@debian.org>  Sun, 05 Apr 2020 18:19:33 +0800

tbb (2020.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 07 Feb 2020 09:32:59 +0800

tbb (2020.1-1) experimental; urgency=medium

  * New upstream version 2020.1
  * Autopkgtest: let cmake test compile a simple C++ program.

 -- Mo Zhou <lumin@debian.org>  Thu, 30 Jan 2020 18:01:05 +0800

tbb (2020.0-2) unstable; urgency=medium

  * Mark libtbb-doc as Multi-Arch: foreign.
  * Merge the content of tbb-examples package into libtbb-doc package.
  * Remove the third-party cmake file FindTBB.cmake
  * CMake: use TBBConfig*.cmake to find TBB. (Closes: #929967)
  * Add a CMakeLists.txt to debian/tests for testing TBBConfig*.cmake
  * Bump debhelper compat level to 12 and deprecate d/compat.
  * Initialize autopkgtest: upstream unit tests, cmake find_package.

 -- Mo Zhou <lumin@debian.org>  Tue, 07 Jan 2020 09:01:17 +0800

tbb (2020.0-1) experimental; urgency=medium

  * New upstream version 2020.0
  * Update watch file, reflecting the version scheme change.
  * Rebase/Refresh existing patch stack.
  * Add missing B-D-I graphviz.
  * Refresh symbols control file.
  * Override a lintian warning.
  * Update my own mail address.
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Jan 2020 17:05:21 +0800

tbb (2019~U9-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 15 Oct 2019 10:06:29 +0000

tbb (2019~U9-1) experimental; urgency=medium

  * New upstream version 2019~U9
  * Rebase gcc-atomic-detection.patch
  * Update symbols list for amd64.

 -- Mo Zhou <cdluminate@gmail.com>  Fri, 11 Oct 2019 21:24:17 +0800

tbb (2019~U8-1) unstable; urgency=medium

  * New upstream version 2019~U8

 -- Mo Zhou <cdluminate@gmail.com>  Sat, 06 Jul 2019 04:48:07 +0000

tbb (2019~U7-1) unstable; urgency=medium

  * New upstream version 2019~U7
  * Rebase gcc-atomic-detection.patch and refresh the rest patches.

 -- Mo Zhou <cdluminate@gmail.com>  Tue, 04 Jun 2019 12:14:14 +0000

tbb (2019~U5-1~exp1) experimental; urgency=medium

  * New upstream version 2019~U5

 -- Mo Zhou <cdluminate@gmail.com>  Thu, 28 Mar 2019 00:34:43 +0000



=== debian/control ===
Source: onetbb
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Steve Capper <steven.capper@gmail.com>,
           Mo Zhou <lumin@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libjs-jquery <!nodoc>,
               libjs-underscore <!nodoc>,
               gdb,
               cmake,
               ninja-build,
               python3-sphinx <!nodoc>,
               python3-sphinx-book-theme <!nodoc>,
Build-Depends-Indep: doxygen, graphviz,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/tbb
Vcs-Git: https://salsa.debian.org/science-team/tbb.git
Homepage: https://www.threadingbuildingblocks.org/
Rules-Requires-Root: no

Package: libtbb-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Depends: libtbb12 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libtbb-doc
Description: parallelism library for C++ - development files
 TBB is a library that helps you leverage multi-core processor
 performance without having to be a threading expert. It represents a
 higher-level, task-based parallelism that abstracts platform details
 and threading mechanism for performance and scalability.
 .
 (Note: if you are a user of the i386 architecture, i.e., 32-bit Intel
 or compatible hardware, this package only supports Pentium4-compatible
 and higher processors.)
 .
 This package includes the TBB development files.

Package: libtbb12
Architecture: linux-any
Multi-Arch: same
Depends: libtbbmalloc2 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: parallelism library for C++ - runtime files
 TBB is a library that helps you leverage multi-core processor
 performance without having to be a threading expert. It represents a
 higher-level, task-based parallelism that abstracts platform details
 and threading mechanism for performance and scalability.
 .
 (Note: if you are a user of the i386 architecture, i.e., 32-bit Intel
 or compatible hardware, this package only supports Pentium4-compatible
 and higher processors.)
 .
 This package includes the TBB runtime files.

Package: libtbbmalloc2
Architecture: linux-any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Breaks: libtbb2 (<< 2020.3-1ubuntu2), libtbb12 (<< 2021.5-7ubuntu2)
Replaces: libtbb2 (<< 2020.3-1ubuntu2), libtbb12 (<< 2021.5-7ubuntu2)
Description: parallelism helper library for C++ - runtime files
 TBB is a library that helps you leverage multi-core processor
 performance without having to be a threading expert. It represents a
 higher-level, task-based parallelism that abstracts platform details
 and threading mechanism for performance and scalability.
 .
 (Note: if you are a user of the i386 architecture, i.e., 32-bit Intel
 or compatible hardware, this package only supports Pentium4-compatible
 and higher processors.)
 .
 This package includes the TBB runtime files.

Package: libtbb-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Breaks: tbb-examples (<< 2020.0-2),
Replaces: tbb-examples (<< 2020.0-2),
Depends: ${misc:Depends},
         libjs-jquery
Recommends: libtbb-dev,
Description: parallelism library for C++ - documentation
 TBB is a library that helps you leverage multi-core processor
 performance without having to be a threading expert. It represents a
 higher-level, task-based parallelism that abstracts platform details
 and threading mechanism for performance and scalability.
 .
 This package includes the TBB documentation files and examples.

=== debian/rules ===
#!/usr/bin/make -f
# export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS   = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/architecture.mk

ifneq (,$(filter $(DEB_BUILD_ARCH), m68k sh4))
BUILD_FLAGS := -DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS) -faligned-new"
else
BUILD_FLAGS := -DCMAKE_CXX_FLAGS="$(CXXFLAGS) $(CPPFLAGS)"
endif

ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
# Provide compiler information
BUILD_FLAGS += -DCMAKE_C_COMPILER=$(DEB_HOST_GNU_TYPE)-gcc
BUILD_FLAGS += -DCMAKE_CXX_COMPILER=$(DEB_HOST_GNU_TYPE)-g++
endif

# explicitly link against libatomic
ifneq (,$(filter $(DEB_BUILD_ARCH),armel mipsel m68k sh4 powerpc))
export DEB_ATOMIC=atomic
endif


%:
	dh $@ -Scmake+ninja

# Common CMake Flags, see upstream documentation
# https://github.com/oneapi-src/oneTBB/blob/master/cmake/README.md
override_dh_auto_configure:
ifeq (ia64,$(DEB_HOST_ARCH))
	# https://github.com/oneapi-src/oneTBB/issues/777
	# This is a quick hack to disable ITT_NOTIFY on IA64
	sed -i -e 's/__TBB_USE_ITT_NOTIFY/__TBB_NO_USE_ITT_NOTIFY/g' src/tbb/CMakeLists.txt
endif
	dh_auto_configure -- \
		-DTBB_TEST=ON \
		-DTBB4PY_BUILD=OFF \
		$(BUILD_FLAGS)

override_dh_auto_build-arch:
# dump out diagnostics
	cat /proc/cpuinfo
	gcc -dM -E - < /dev/null
	echo Build system page size is $$(($$(getconf PAGESIZE) >> 10)) KiB
	dh_auto_build

override_dh_auto_build-indep:
	sphinx-build -b html doc/main html
	# strip the links to prevent privacy breach
	-find html -type f -exec sed -i -e \
		's@https://www.intel.com/content/dam/www/global/wap/performance-config.js@https://localhost/performance-config.js@g' '{}' \;
	# don't ship embedded fonts
	-$(RM) -rf html/_static/vendor
	# remove .doctree junk
	-$(RM) -rf html/.doctrees
	# remove pycache
	-$(RM) -rf html/_static/__pycache__
	# remove embedded javascripts. they will be provided by other system packages (see .links)
	-$(RM) html/_static/*.js

override_dh_auto_test-indep:
	:

override_dh_auto_install-indep:
	:

# Makefiles should not be compressed (tbb-examples)
override_dh_compress-indep:
	dh_compress -X*/examples/*

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/oneapi-src/oneTBB/releases \
(?:.*?/)?v?(\d[\d.]*)\.tar\.gz
